# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

## [2.1.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.1...@rest-hooks/core@2.1.0) (2021-09-19)


### 🚀 Features

* Add Controller ([#1239](https://github.com/coinbase/rest-hooks/issues/1239)) ([321dbaa](https://github.com/coinbase/rest-hooks/commit/321dbaa905744b5d331a163d4a0f219809f740ee))
* Send controller to middlewares ([#1271](https://github.com/coinbase/rest-hooks/issues/1271)) ([29db53c](https://github.com/coinbase/rest-hooks/commit/29db53c8ee7f5d770dd43b6e3d97346bc77f76d7))


### 📝 Documentation

* Random fixes ([#1261](https://github.com/coinbase/rest-hooks/issues/1261)) ([ec90154](https://github.com/coinbase/rest-hooks/commit/ec901542a5157b35e20a346b7794f986f775138c))



### [2.0.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0...@rest-hooks/core@2.0.1) (2021-09-14)

**Note:** Version bump only for package @rest-hooks/core





## [2.0.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.6...@rest-hooks/core@2.0.0) (2021-09-08)


### 🐛 Bug Fix

* Updating nesting under arrays ([#1047](https://github.com/coinbase/rest-hooks/issues/1047)) ([a78a1a4](https://github.com/coinbase/rest-hooks/commit/a78a1a41149dbb0646660fdeef38918b2e16cc14))


### 📝 Documentation

* Add links to protocol specific docs ([#1218](https://github.com/coinbase/rest-hooks/issues/1218)) ([1570881](https://github.com/coinbase/rest-hooks/commit/1570881372bb1cc0a3d4034c24543bb8ea5d99c1))
* Add more tags to packages ([#1223](https://github.com/coinbase/rest-hooks/issues/1223)) ([ef76efc](https://github.com/coinbase/rest-hooks/commit/ef76efc70f7c6acb73d22135a227f84e522729b4))



## [2.0.0-beta.6](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.5...@rest-hooks/core@2.0.0-beta.6) (2021-09-06)


### 💅 Enhancement

* Give errors a name ([#1195](https://github.com/coinbase/rest-hooks/issues/1195)) ([caa1cd4](https://github.com/coinbase/rest-hooks/commit/caa1cd4c365eedc0e6bc8df6b00b9bfdf6492c63))
* Improve robustness for legacy RESET actions ([#1213](https://github.com/coinbase/rest-hooks/issues/1213)) ([da6ee6c](https://github.com/coinbase/rest-hooks/commit/da6ee6c21d37b8ea5fa75ff15284c79bd9eb1269))
* validate during denormalization ([#1183](https://github.com/coinbase/rest-hooks/issues/1183)) ([bca1e4a](https://github.com/coinbase/rest-hooks/commit/bca1e4a9158a294ee82745107e04e43564ccd5a0))
* Warn users if they are missing Suspense boundary ([#1169](https://github.com/coinbase/rest-hooks/issues/1169)) ([ccf819a](https://github.com/coinbase/rest-hooks/commit/ccf819ab65163aa056a3317e1c1eca17c003ecf6))



## [2.0.0-beta.5](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.4...@rest-hooks/core@2.0.0-beta.5) (2021-08-25)


### 💅 Enhancement

* Back to avoiding reducer for fetch ([#1149](https://github.com/coinbase/rest-hooks/issues/1149)) ([06ae6a4](https://github.com/coinbase/rest-hooks/commit/06ae6a450f65f0344a44e2c8d162b62e7461bfe8))



## [2.0.0-beta.4](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.3...@rest-hooks/core@2.0.0-beta.4) (2021-08-22)


### 🐛 Bug Fix

* Cannot update a component while rendering a different component ([#1130](https://github.com/coinbase/rest-hooks/issues/1130)) ([0003388](https://github.com/coinbase/rest-hooks/commit/00033882ec88338b94bd78c8a7a5ad2954af40d6))



## [2.0.0-beta.3](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.2...@rest-hooks/core@2.0.0-beta.3) (2021-08-21)


### 💅 Enhancement

* Experimental fetcher resolves before react render ([#1046](https://github.com/coinbase/rest-hooks/issues/1046)) ([1ec90e5](https://github.com/coinbase/rest-hooks/commit/1ec90e5bb8d69bb47a4099a137c0935cd001c4fb))
* Hide throttled fetches from devtools ([#1083](https://github.com/coinbase/rest-hooks/issues/1083)) ([2f09c22](https://github.com/coinbase/rest-hooks/commit/2f09c227ef9dcc056a4e9f1c76b725aa063964d6))
* Improve reducer error visibility ([#1084](https://github.com/coinbase/rest-hooks/issues/1084)) ([b69a50d](https://github.com/coinbase/rest-hooks/commit/b69a50d7b3d658c0b4c7f6c198fe8e2a76ec8aa9))


### 🐛 Bug Fix

* RESET clears inflight fetches ([#1085](https://github.com/coinbase/rest-hooks/issues/1085)) ([02fa0d5](https://github.com/coinbase/rest-hooks/commit/02fa0d527ef138961ba6dc2509648337c01e604d))
* useFetchInit() hook calls same amount every render ([#1123](https://github.com/coinbase/rest-hooks/issues/1123)) ([6cd0b7c](https://github.com/coinbase/rest-hooks/commit/6cd0b7cc57de59b5f394942dfa9a3a08d9f2e912))



## [2.0.0-beta.2](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.5.3...@rest-hooks/core@2.0.0-beta.2) (2021-07-12)


### ⚠ 💥 BREAKING CHANGES

* * Importing directly from hidden files is no longer supported
* Node>=12
* - Removed: SyntheticError (untriggerable since https://github.com/coinbase/rest-hooks/pull/938)
- @rest-hooks/rest: 500s are 'soft', else 'hard'
- PollingSubscription: any errors are 'soft'
- @rest-hooks/endpoint: no default errorPolicy, therefore all errors are
'hard'
* Rest Hooks 4 invalidIfStale behavior completely removed
* buildInferredResult removed. use inferResults instead
* - fromJS() -> process() to customize init
- normalize results in POJO rather than instances
- FlatEntity, SimpleRecord removed (use @rest-hooks/legacy)
- peerDep @rest-hooks/endpoint > 2
* - Removed exports from 'rest-hooks': NestedEntity, schemas, isEntity, Entity, Resource, SimpleResource, SchemaDetail, SchemaList, Method
- use @rest-hooks/legacy, or @rest-hooks/rest instead
* useError() will no longer create synthetic
errors for missing entities

### 🚀 Features

* Add errorPolicy to endpoint options ([#971](https://github.com/coinbase/rest-hooks/issues/971)) ([836f05b](https://github.com/coinbase/rest-hooks/commit/836f05b407b5ac96c8f094e652221aa5a95300b0))
* FixtureEndpoint & renderRestHook resolverFixtures ([#1027](https://github.com/coinbase/rest-hooks/issues/1027)) ([bbb69e9](https://github.com/coinbase/rest-hooks/commit/bbb69e9faaa523c46a0e309a44e0fd52f0ce91aa))
* Use 'exports' package.json member ([#955](https://github.com/coinbase/rest-hooks/issues/955)) ([7e9d39f](https://github.com/coinbase/rest-hooks/commit/7e9d39f15b4b321352ece0caddb93e2c414df8ae))


### 💅 Enhancement

* Different babel targets for cjs and umd builds ([#989](https://github.com/coinbase/rest-hooks/issues/989)) ([f054814](https://github.com/coinbase/rest-hooks/commit/f05481410cf8daa2101d4dbda826e56ad10ec723))
* Entities normalize to POJO ([#940](https://github.com/coinbase/rest-hooks/issues/940)) ([75ebdfe](https://github.com/coinbase/rest-hooks/commit/75ebdfe641ccf57fca35c44a94077e4a314e44d7))
* Remove 'fallback' package.json exports ([#992](https://github.com/coinbase/rest-hooks/issues/992)) ([dc95f9d](https://github.com/coinbase/rest-hooks/commit/dc95f9dbad20d5740218c52c906596b6a3d6eae4))
* Remove buildInferredResult() ([#941](https://github.com/coinbase/rest-hooks/issues/941)) ([c137aa7](https://github.com/coinbase/rest-hooks/commit/c137aa78302541f0167c2cfd32c30b34a3ba971f))
* Remove extraneous hack for expiresAt ([#970](https://github.com/coinbase/rest-hooks/issues/970)) ([0602376](https://github.com/coinbase/rest-hooks/commit/06023760266ed572697605c45bd7e271406badd3))
* Remove Resource export from 'rest-hooks' package ([#939](https://github.com/coinbase/rest-hooks/issues/939)) ([0707920](https://github.com/coinbase/rest-hooks/commit/0707920bd9de70112b5287d101dcd4f6962f21d1))
* schema not needed in action ([#1029](https://github.com/coinbase/rest-hooks/issues/1029)) ([2a2fe3a](https://github.com/coinbase/rest-hooks/commit/2a2fe3a27a57e5ac45f95e9f65ce81751f898f12))
* Use optional chaining ([#1003](https://github.com/coinbase/rest-hooks/issues/1003)) ([6e45937](https://github.com/coinbase/rest-hooks/commit/6e459377e3f0d90d1832c0173358c3c73f253831))
* useError() only checks meta error ([#938](https://github.com/coinbase/rest-hooks/issues/938)) ([b08d708](https://github.com/coinbase/rest-hooks/commit/b08d708ea50170de0dd25340aec84b86a7687f48))


### 🐛 Bug Fix

* module build import path ([#994](https://github.com/coinbase/rest-hooks/issues/994)) ([1f84f51](https://github.com/coinbase/rest-hooks/commit/1f84f51e0f3b62832945e75d0e241dba59b6623c))


### 📝 Documentation

* Add doc links to jsdocs ([#966](https://github.com/coinbase/rest-hooks/issues/966)) ([dc7fcfe](https://github.com/coinbase/rest-hooks/commit/dc7fcfec24c30d5f405d24ccc1828620d837ea6b))



## [2.0.0-beta.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@2.0.0-beta.0...@rest-hooks/core@2.0.0-beta.1) (2021-06-30)


### 🐛 Bug Fix

* module build import path ([#994](https://github.com/coinbase/rest-hooks/issues/994)) ([1f84f51](https://github.com/coinbase/rest-hooks/commit/1f84f51e0f3b62832945e75d0e241dba59b6623c))



## [2.0.0-beta.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.5.2...@rest-hooks/core@2.0.0-beta.0) (2021-06-30)


### ⚠ 💥 BREAKING CHANGES

* * Importing directly from hidden files is no longer supported
* Node>=12
* - Removed: SyntheticError (untriggerable since https://github.com/coinbase/rest-hooks/pull/938)
- @rest-hooks/rest: 500s are 'soft', else 'hard'
- PollingSubscription: any errors are 'soft'
- @rest-hooks/endpoint: no default errorPolicy, therefore all errors are
'hard'
* Rest Hooks 4 invalidIfStale behavior completely removed
* buildInferredResult removed. use inferResults instead
* - fromJS() -> process() to customize init
- normalize results in POJO rather than instances
- FlatEntity, SimpleRecord removed (use @rest-hooks/legacy)
- peerDep @rest-hooks/endpoint > 2
* - Removed exports from 'rest-hooks': NestedEntity, schemas, isEntity, Entity, Resource, SimpleResource, SchemaDetail, SchemaList, Method
- use @rest-hooks/legacy, or @rest-hooks/rest instead
* useError() will no longer create synthetic
errors for missing entities

### 🚀 Features

* Add errorPolicy to endpoint options ([#971](https://github.com/coinbase/rest-hooks/issues/971)) ([836f05b](https://github.com/coinbase/rest-hooks/commit/836f05b407b5ac96c8f094e652221aa5a95300b0))
* Use 'exports' package.json member ([#955](https://github.com/coinbase/rest-hooks/issues/955)) ([7e9d39f](https://github.com/coinbase/rest-hooks/commit/7e9d39f15b4b321352ece0caddb93e2c414df8ae))


### 💅 Enhancement

* Different babel targets for cjs and umd builds ([#989](https://github.com/coinbase/rest-hooks/issues/989)) ([f054814](https://github.com/coinbase/rest-hooks/commit/f05481410cf8daa2101d4dbda826e56ad10ec723))
* Entities normalize to POJO ([#940](https://github.com/coinbase/rest-hooks/issues/940)) ([75ebdfe](https://github.com/coinbase/rest-hooks/commit/75ebdfe641ccf57fca35c44a94077e4a314e44d7))
* Remove 'fallback' package.json exports ([#992](https://github.com/coinbase/rest-hooks/issues/992)) ([dc95f9d](https://github.com/coinbase/rest-hooks/commit/dc95f9dbad20d5740218c52c906596b6a3d6eae4))
* Remove buildInferredResult() ([#941](https://github.com/coinbase/rest-hooks/issues/941)) ([c137aa7](https://github.com/coinbase/rest-hooks/commit/c137aa78302541f0167c2cfd32c30b34a3ba971f))
* Remove extraneous hack for expiresAt ([#970](https://github.com/coinbase/rest-hooks/issues/970)) ([0602376](https://github.com/coinbase/rest-hooks/commit/06023760266ed572697605c45bd7e271406badd3))
* Remove Resource export from 'rest-hooks' package ([#939](https://github.com/coinbase/rest-hooks/issues/939)) ([0707920](https://github.com/coinbase/rest-hooks/commit/0707920bd9de70112b5287d101dcd4f6962f21d1))
* useError() only checks meta error ([#938](https://github.com/coinbase/rest-hooks/issues/938)) ([b08d708](https://github.com/coinbase/rest-hooks/commit/b08d708ea50170de0dd25340aec84b86a7687f48))


### 📝 Documentation

* Add doc links to jsdocs ([#966](https://github.com/coinbase/rest-hooks/issues/966)) ([dc7fcfe](https://github.com/coinbase/rest-hooks/commit/dc7fcfec24c30d5f405d24ccc1828620d837ea6b))

### [1.5.3](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.5.2...@rest-hooks/core@1.5.3) (2021-07-06)

**Note:** Version bump only for package @rest-hooks/core





### [1.5.2](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.5.1...@rest-hooks/core@1.5.2) (2021-06-19)

**Note:** Version bump only for package @rest-hooks/core





### [1.5.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.5.0...@rest-hooks/core@1.5.1) (2021-06-16)

**Note:** Version bump only for package @rest-hooks/core





## [1.5.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.4.1...@rest-hooks/core@1.5.0) (2021-06-13)


### 🚀 Features

* Normalize merges entities, entitymeta, indexes ([#915](https://github.com/coinbase/rest-hooks/issues/915)) ([bd21d8c](https://github.com/coinbase/rest-hooks/commit/bd21d8ce0d004a56e6853918d9fb9ecaa2c730a8))
* Support React 18 ([#907](https://github.com/coinbase/rest-hooks/issues/907)) ([63e8bc9](https://github.com/coinbase/rest-hooks/commit/63e8bc9887a080e1aa510d972645c037dfc96128))


### 💅 Enhancement

* Use inferResults() from normalizr ([#901](https://github.com/coinbase/rest-hooks/issues/901)) ([875cb6a](https://github.com/coinbase/rest-hooks/commit/875cb6acf31055e37e2d1faf4414bcbf31f5700f))



### [1.4.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.4.0...@rest-hooks/core@1.4.1) (2021-06-09)


### 💅 Enhancement

* 'module' entrypoint targets 2019 browsers ([#905](https://github.com/coinbase/rest-hooks/issues/905)) ([d988abe](https://github.com/coinbase/rest-hooks/commit/d988abe063fc67c74fce12e234c9c3ffdb7cc230))



## [1.4.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.2.1...@rest-hooks/core@1.4.0) (2021-06-02)


### 🚀 Features

* Add garbage collection action ([#865](https://github.com/coinbase/rest-hooks/issues/865)) ([aab7ad6](https://github.com/coinbase/rest-hooks/commit/aab7ad6045a08417f53b778a7ea4d2611f6cac06))


### 💅 Enhancement

* Improve autoimport handling in vscode ([#890](https://github.com/coinbase/rest-hooks/issues/890)) ([f8f2bef](https://github.com/coinbase/rest-hooks/commit/f8f2bef411183676009c6a9df24a26d147c6d9f6))



## [1.3.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.2.1...@rest-hooks/core@1.3.0) (2021-05-30)


### 🚀 Features

* Add garbage collection action ([#865](https://github.com/coinbase/rest-hooks/issues/865)) ([aab7ad6](https://github.com/coinbase/rest-hooks/commit/aab7ad6045a08417f53b778a7ea4d2611f6cac06))



### [1.2.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.2.0...@rest-hooks/core@1.2.1) (2021-05-24)


### 💅 Enhancement

* Provide args to update method ([#852](https://github.com/coinbase/rest-hooks/issues/852)) ([a552977](https://github.com/coinbase/rest-hooks/commit/a552977752c0f89852e0814cebd3956f0e1338bd))
* Support endpoint.update in existing useFetcher ([#853](https://github.com/coinbase/rest-hooks/issues/853)) ([2436f3b](https://github.com/coinbase/rest-hooks/commit/2436f3b9e6f91fc73178476d3ca88605349bba33))
* Transform updateParams to 'update' function ([#854](https://github.com/coinbase/rest-hooks/issues/854)) ([7ef3e2a](https://github.com/coinbase/rest-hooks/commit/7ef3e2a646421356029294e440e1a2e000b05f05))



## [1.2.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.1.2...@rest-hooks/core@1.2.0) (2021-05-24)


### 🚀 Features

* Endpoint.update programmable sideeffects ([#843](https://github.com/coinbase/rest-hooks/issues/843)) ([3b011b2](https://github.com/coinbase/rest-hooks/commit/3b011b2ab7d3f2fd6588bd26c566bf542beeba49))


### 💅 Enhancement

* Do not throw on unmount of CacheProvider ([#837](https://github.com/coinbase/rest-hooks/issues/837)) ([f7dcf24](https://github.com/coinbase/rest-hooks/commit/f7dcf24d2b6123ab84470263d505a975591bd9b4))



### [1.1.2](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.1.1...@rest-hooks/core@1.1.2) (2021-04-26)


### 🐛 Bug Fix

* useMeta() parameters type ([#775](https://github.com/coinbase/rest-hooks/issues/775)) ([9f7fae4](https://github.com/coinbase/rest-hooks/commit/9f7fae4dba0d797fdfac114e52cdd5ea90f4d61f))



### [1.1.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.1.0...@rest-hooks/core@1.1.1) (2021-04-25)


### 💅 Enhancement

* Make hook generics use consist params ([#769](https://github.com/coinbase/rest-hooks/issues/769)) ([5a68f2a](https://github.com/coinbase/rest-hooks/commit/5a68f2a5d9d942436f08c513b8b56c78718f14aa))


### 🐛 Bug Fix

* Delete should only be triggered on finding DELETE symbol ([#770](https://github.com/coinbase/rest-hooks/issues/770)) ([20886f6](https://github.com/coinbase/rest-hooks/commit/20886f65cba2e741e1496990123f97f38852aaf4))



## [1.1.0](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.16...@rest-hooks/core@1.1.0) (2021-04-24)


### 🚀 Features

* Endpoint parameters can be of any length ([#767](https://github.com/coinbase/rest-hooks/issues/767)) ([552f837](https://github.com/coinbase/rest-hooks/commit/552f83740279376288879a661ff487c5c6f1d469))



### [1.0.16](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.15...@rest-hooks/core@1.0.16) (2021-04-13)


### 💅 Enhancement

* Remove extraneous outdated hack ([#750](https://github.com/coinbase/rest-hooks/issues/750)) ([da7e7cb](https://github.com/coinbase/rest-hooks/commit/da7e7cbedd6264b26f6158079d9224f52fe2f829))


### 🐛 Bug Fix

* Generate types that do not refer internally to other packages ([#749](https://github.com/coinbase/rest-hooks/issues/749)) ([2e55e32](https://github.com/coinbase/rest-hooks/commit/2e55e3229f23ba1d0d6eb15faf3dd5ba3de838c4))



### [1.0.15](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.14...@rest-hooks/core@1.0.15) (2021-04-12)


### 🐛 Bug Fix

* Relax DeleteShape def to be back-compat ([#743](https://github.com/coinbase/rest-hooks/issues/743)) ([20aa3a0](https://github.com/coinbase/rest-hooks/commit/20aa3a09bbe4419c23e37b331ca3208349f0e07c))



### [1.0.14](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.13...@rest-hooks/core@1.0.14) (2021-04-12)


### 🐛 Bug Fix

* Publish legacy type files ([#741](https://github.com/coinbase/rest-hooks/issues/741)) ([bbae8bd](https://github.com/coinbase/rest-hooks/commit/bbae8bd44d9870e7f6ed599b0751ad264f9f2313))



### [1.0.13](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.12...@rest-hooks/core@1.0.13) (2021-04-12)


### 💅 Enhancement

* All schema members are optional by default ([#716](https://github.com/coinbase/rest-hooks/issues/716)) ([b8c6443](https://github.com/coinbase/rest-hooks/commit/b8c64438bb34bc1f9e9bc1461bd7e4d3bb4e330e))
* Refined deleteShape() definition ([#734](https://github.com/coinbase/rest-hooks/issues/734)) ([e34526d](https://github.com/coinbase/rest-hooks/commit/e34526d5dde5a2cc317cd9428ededc6a9893dc41))
* Support TypeScript 3, while using TypeScript 4 features ([#726](https://github.com/coinbase/rest-hooks/issues/726)) ([4db2522](https://github.com/coinbase/rest-hooks/commit/4db2522b9060a7f7aaba4a93c3cf1694eb3d5364))
* Use namedtuples for denormalize ([#733](https://github.com/coinbase/rest-hooks/issues/733)) ([83382cc](https://github.com/coinbase/rest-hooks/commit/83382cce716ec22949127cc0f190bbeddf5a3722))


### 🐛 Bug Fix

* Inferring schema.Values() ([#732](https://github.com/coinbase/rest-hooks/issues/732)) ([1a77a03](https://github.com/coinbase/rest-hooks/commit/1a77a03a5c06b352feb467958be2e6e3f8f91003))
* schema.Values singleSchema denormalization ([#723](https://github.com/coinbase/rest-hooks/issues/723)) ([99317d1](https://github.com/coinbase/rest-hooks/commit/99317d17db8293d6bf987d1cbfa99691cf58903e))



### [1.0.12](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.11...@rest-hooks/core@1.0.12) (2021-04-04)

**Note:** Version bump only for package @rest-hooks/core





### [1.0.11](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.10...@rest-hooks/core@1.0.11) (2021-03-26)


### 🐛 Bug Fix

* Compatibility with TypeScript strict: false ([#683](https://github.com/coinbase/rest-hooks/issues/683)) ([8a6e7ed](https://github.com/coinbase/rest-hooks/commit/8a6e7ed4d179555c4ba5cb8957b1c63697a1ce1a))


### 📝 Documentation

* Update package description ([#684](https://github.com/coinbase/rest-hooks/issues/684)) ([c2b6915](https://github.com/coinbase/rest-hooks/commit/c2b6915c3a055816f345634416aeae9196de7051))



### [1.0.10](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.9...@rest-hooks/core@1.0.10) (2021-03-24)

**Note:** Version bump only for package @rest-hooks/core





### [1.0.9](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.8...@rest-hooks/core@1.0.9) (2021-03-14)


### 📝 Documentation

* Update package tags ([#650](https://github.com/coinbase/rest-hooks/issues/650)) ([4ef465a](https://github.com/coinbase/rest-hooks/commit/4ef465a129cd59668cd9c3542bb9ec03c84d2a4d))



### [1.0.8](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.7...@rest-hooks/core@1.0.8) (2021-03-08)


### 💅 Enhancement

* Don't use global for rIC def ([#617](https://github.com/coinbase/rest-hooks/issues/617)) ([ed33203](https://github.com/coinbase/rest-hooks/commit/ed33203aa8685953e0d09c831343480e0e2e6051))



### [1.0.7](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.6...@rest-hooks/core@1.0.7) (2021-03-03)


### 🐛 Bug Fix

* useStatefulResource() return type ([#613](https://github.com/coinbase/rest-hooks/issues/613)) ([05a4995](https://github.com/coinbase/rest-hooks/commit/05a49954c61f47deef18bc5d58d045ac79efd78e))



### [1.0.6](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.5...@rest-hooks/core@1.0.6) (2021-03-01)


### 💅 Enhancement

* Support 'undefined' as schema ([#583](https://github.com/coinbase/rest-hooks/issues/583)) ([1e81470](https://github.com/coinbase/rest-hooks/commit/7ef172a3d8469b182cc7a19055920a308841b59e))



### [1.0.5](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.4...@rest-hooks/core@1.0.5) (2021-02-27)


### 💅 Enhancement

* Make type discrimination easier in error types ([#581](https://github.com/coinbase/rest-hooks/issues/581)) ([cd105f3](https://github.com/coinbase/rest-hooks/commit/cd105f378e3c97b6accd127a61759287fb8bb3b5))



### [1.0.4](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.3...@rest-hooks/core@1.0.4) (2021-02-24)


### 💅 Enhancement

* Improve error type preciseness ([#571](https://github.com/coinbase/rest-hooks/issues/571)) ([6f760be](https://github.com/coinbase/rest-hooks/commit/6f760be7149f04eb26727730e0ec0d67f2215ed5))
* legacy Resource should only warn on validation problems ([#540](https://github.com/coinbase/rest-hooks/issues/540)) ([eb83a51](https://github.com/coinbase/rest-hooks/commit/eb83a511d41c0b18ea3f5ecd6696e1013ed8e1c3))



### [1.0.3](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.2...@rest-hooks/core@1.0.3) (2021-02-04)


### 📦 Package

* Relax @babel/runtime requirement to ^7.7.2 ([#513](https://github.com/coinbase/rest-hooks/issues/513)) ([cc95b21](https://github.com/coinbase/rest-hooks/commit/cc95b219fbddebfbf334728887ca6d2fa070fce1))


### 📝 Documentation

* Link improvements, flesh out test readme ([#511](https://github.com/coinbase/rest-hooks/issues/511)) ([9cab431](https://github.com/coinbase/rest-hooks/commit/9cab431803a8b7d9c18e02b3e9cb7e336215ccdb))



### [1.0.2](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.1...@rest-hooks/core@1.0.2) (2021-01-30)

**Note:** Version bump only for package @rest-hooks/core





### [1.0.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0...@rest-hooks/core@1.0.1) (2021-01-24)


### 💅 Enhancement

* Add `static automaticValidation` to Entity ([#495](https://github.com/coinbase/rest-hooks/issues/495)) ([034450d](https://github.com/coinbase/rest-hooks/commit/034450d2eb00fab636ca4db5138b6a0573620db6))
* Improve malformed entity detection ([#494](https://github.com/coinbase/rest-hooks/issues/494)) ([b8bb07f](https://github.com/coinbase/rest-hooks/commit/b8bb07f480549a97254a4fdf6b00acd9cb89a9eb))


### 🐛 Bug Fix

* Support TypeScript <4 ([#489](https://github.com/coinbase/rest-hooks/issues/489)) ([267b541](https://github.com/coinbase/rest-hooks/commit/267b5412cf4e65f6e523aad764203b91a92cc427))


### 📝 Documentation

* Improve rest-types and network transform ([#486](https://github.com/coinbase/rest-hooks/issues/486)) ([e61342a](https://github.com/coinbase/rest-hooks/commit/e61342acc920288ecb98f36e9aa8ecb13dd6fe44))
* Update wording for 'cache lifetime' in feature list ([#483](https://github.com/coinbase/rest-hooks/issues/483)) ([5a62b73](https://github.com/coinbase/rest-hooks/commit/5a62b73d66cc232e21f5f8792e8d6f63d094b9f2))



## 1.0.0 (2021-01-19)


### ⚠ 💥 BREAKING CHANGES

* Remove `normalize`, `denormalize`; use
`normalizr` package for those
* Resources will resolve with any nested
entities from their schemas, rather than the `pk` of those
entities
* useResource() inferred endpoint will sometimes
not trigger a fetch if entities are fresh enough
* Node engine requirement of >=0.12
* getFetchOptions() -> getEndpointExtra()
* - Removed Resource.fetchOptionsPlugin()
- Added Resource.getFetchInit() which is called in shape generators
- Resourece.fetch() interface changed to match browser fetch()
* - denormalize has third boolean value to track deletion
- deletes no long remove entities, but replace them with DELETE symbol (exported from normalizr)
- schema of delete shape should be the `new schemas.Delete()`
- useInvalidator()'s function calls will always suspend - even without invalidIfStale
- deleted entities that are required by a useResource() will now cause it to suspend rather than throwing `404`
- required entities missing from network response will now throw error in useResource() just like other unexpected deserializations
- FetchShape type is now just 'read' | 'mutate'. No more 'delete'. (use schema.Delete())

### 🚀 Features

* Add @rest-hooks/hooks for composable utilities ([#393](https://github.com/coinbase/rest-hooks/issues/393)) ([b225a2a](https://github.com/coinbase/rest-hooks/commit/b225a2a80d68a94a3e0a68cf6f5289220373f022))
* Add @rest-hooks/rest package ([#375](https://github.com/coinbase/rest-hooks/issues/375)) ([5e5c125](https://github.com/coinbase/rest-hooks/commit/5e5c125d3396ebbb8514aea6fc80b4dfceb0da27))
* Add DevToolsManager to integrate with redux-devtools ([#371](https://github.com/coinbase/rest-hooks/issues/371)) ([aa171bc](https://github.com/coinbase/rest-hooks/commit/aa171bc0b3eb07d6715869fde0142023dbdde2e6))
* Add fetch request creation time to meta ([1a6242f](https://github.com/coinbase/rest-hooks/commit/1a6242f3fae175ed555de43a1b93162674994692))
* Add useInvalidateDispatcher() ([#413](https://github.com/coinbase/rest-hooks/issues/413)) ([e416c5f](https://github.com/coinbase/rest-hooks/commit/e416c5f2087fc13f6d810edd8a105db58a737ad6))
* Declarative schema deserialization ([#355](https://github.com/coinbase/rest-hooks/issues/355)) ([9dbb019](https://github.com/coinbase/rest-hooks/commit/9dbb01990d7082af2b06f61e3d2deead2a747f76))
* Deletes and invalidates trigger suspense always ([#360](https://github.com/coinbase/rest-hooks/issues/360)) ([96175ba](https://github.com/coinbase/rest-hooks/commit/96175ba24d6670d866b315794b039d21fd3ef081))
* Resource.fetch() arguments reflect browser fetch() ([#362](https://github.com/coinbase/rest-hooks/issues/362)) ([1d19421](https://github.com/coinbase/rest-hooks/commit/1d194211c99f2d47cf858d54fd49f06e1fd32eb1))
* Resources can have nested entities ([#469](https://github.com/coinbase/rest-hooks/issues/469)) ([4eeeaae](https://github.com/coinbase/rest-hooks/commit/4eeeaae1026715be4e72a66cd94d81934f2b0ce7))
* Simple AbortController integration ([#392](https://github.com/coinbase/rest-hooks/issues/392)) ([899563d](https://github.com/coinbase/rest-hooks/commit/899563deccaccc214c3504b91b96e1460ddfab2f))
* Support extra endpoint members and inheritance ([#387](https://github.com/coinbase/rest-hooks/issues/387)) ([6ad5486](https://github.com/coinbase/rest-hooks/commit/6ad5486b6e333d8721b74fd4fb1b7ed783461435))
* Track and use entity resolution time ([54203f9](https://github.com/coinbase/rest-hooks/commit/54203f994a166a4ed786328c2ef85b20749a8d6b))
* useFetchDispatcher() ([#407](https://github.com/coinbase/rest-hooks/issues/407)) ([f4e45be](https://github.com/coinbase/rest-hooks/commit/f4e45be370b99bdaf31b5f9dba77fbd55da2f1ea))


### 💅 Enhancement

* `endpoint` package only exports definitions ([#473](https://github.com/coinbase/rest-hooks/issues/473)) ([51dcafe](https://github.com/coinbase/rest-hooks/commit/51dcafe98631998a1db1959f2796d7122d96960b))
* Add back remaining normalizr exports to rest-hooks ([b6878ee](https://github.com/coinbase/rest-hooks/commit/b6878eebbf1572a4b859828da81a058bc5c118e3))
* Add more information when network receive fails ([67ead66](https://github.com/coinbase/rest-hooks/commit/67ead6689247fbded88893acc83c711b1af75997))
* console instead of throw when missing frequency ([8708b1f](https://github.com/coinbase/rest-hooks/commit/8708b1f92a4a782bb0094471943f10541377a94b))
* Infer a reasonble type for fetch responses by default ([9d8c44c](https://github.com/coinbase/rest-hooks/commit/9d8c44cf2dfc085a8d5ad16fcc14095849283c68))
* Inferred endpoints expiry based on entities ([#464](https://github.com/coinbase/rest-hooks/issues/464)) ([975e0d8](https://github.com/coinbase/rest-hooks/commit/975e0d8ce1516d9cd62c00de7f1cce331fd4560a))
* Maintain referential equality globally ([#403](https://github.com/coinbase/rest-hooks/issues/403)) ([e1e353d](https://github.com/coinbase/rest-hooks/commit/e1e353dfc64725c79ab99bb6a0c85114399c6dfc))
* Make Endpoint compatible with FetchShape ([caa967c](https://github.com/coinbase/rest-hooks/commit/caa967ceaa0c1288b15711b0c18b132689b94cc1))
* New package @rest-hooks/core ([#336](https://github.com/coinbase/rest-hooks/issues/336)) ([bf490c0](https://github.com/coinbase/rest-hooks/commit/bf490c030feb8a0e35e96c6dd7d180e45ac8bfd0))
* Resource uses endpoint ([#365](https://github.com/coinbase/rest-hooks/issues/365)) ([4472106](https://github.com/coinbase/rest-hooks/commit/4472106afd05ad060399f0cd3a872ed07e3350ec))
* Simplify endpoint memoization and provide new extensions ([#391](https://github.com/coinbase/rest-hooks/issues/391)) ([d874d0b](https://github.com/coinbase/rest-hooks/commit/d874d0b3e6433a616d2dbecd8076715f5caefaeb))
* Support React 17 ([#397](https://github.com/coinbase/rest-hooks/issues/397)) ([a833f07](https://github.com/coinbase/rest-hooks/commit/a833f0724c60fbb2dd3ff6d7d791ee53c3eff694))
* Widen RestFetch types to make overriding not break ([#479](https://github.com/coinbase/rest-hooks/issues/479)) ([2bccf12](https://github.com/coinbase/rest-hooks/commit/2bccf12f7892ccbc1d342bd529b3659c2935fb71))


### 🐛 Bug Fix

* Accept null as payload of fetch ([4ff4d06](https://github.com/coinbase/rest-hooks/commit/4ff4d0662e73e053746e7491cf946c55d71baf52))
* Clear invalidIfStale protections on mount ([#357](https://github.com/coinbase/rest-hooks/issues/357)) ([b9a89dc](https://github.com/coinbase/rest-hooks/commit/b9a89dc0ca7f64c0082db7a6a7ef3ec5f4d05779))
* Clear promises on cleanup ([#422](https://github.com/coinbase/rest-hooks/issues/422)) ([bcb236e](https://github.com/coinbase/rest-hooks/commit/bcb236e3baae8ea348a8e49aade5bc0ffedf1ffc))
* Export Endpoint through core ([8b60dea](https://github.com/coinbase/rest-hooks/commit/8b60dea6c85518bbd32b088440e591614d3a11f0))
* extend() correctly keeps options for FetchShape compat ([bf522a2](https://github.com/coinbase/rest-hooks/commit/bf522a2d138dc6bc700e9e5b7f9c9bc1dfd9e148))
* Handle entities updated with new indexes ([#384](https://github.com/coinbase/rest-hooks/issues/384)) ([2ee3bb6](https://github.com/coinbase/rest-hooks/commit/2ee3bb60217bed1f91a6d3d086b354ce151b8e0c))
* Infer useFetcher() has no body when not present in fetch ([#385](https://github.com/coinbase/rest-hooks/issues/385)) ([22dd399](https://github.com/coinbase/rest-hooks/commit/22dd3995c519e1990f2388b6365494cec873d04a))
* Inferred return of useCache() ([#377](https://github.com/coinbase/rest-hooks/issues/377)) ([ce7a4f7](https://github.com/coinbase/rest-hooks/commit/ce7a4f7de2fb22a09d2db57696233a99058f30ea))
* Inferred return type of useFetcher() should be promise ([18f5654](https://github.com/coinbase/rest-hooks/commit/18f565491eecd69aa4b76774937e7dfd82822788))
* Looping fetches should still expire at some point ([ef560a9](https://github.com/coinbase/rest-hooks/commit/ef560a93c0f5b4f0aed97bc6c52e75e0229c8fc7))
* No entity schemas should suspend when they have no results ([#344](https://github.com/coinbase/rest-hooks/issues/344)) ([d3cd45e](https://github.com/coinbase/rest-hooks/commit/d3cd45e03bd639c49bf010ff848d4a158f0e6bf9))
* Normalizr errors reject and throw in useResource() ([#352](https://github.com/coinbase/rest-hooks/issues/352)) ([1596b22](https://github.com/coinbase/rest-hooks/commit/1596b22ae0d7e453a189b508fd821ff506d4f823))
* Only block suspense if errors are synthetic ([#410](https://github.com/coinbase/rest-hooks/issues/410)) ([af8ab26](https://github.com/coinbase/rest-hooks/commit/af8ab267e4fab27e714e38e0ff9bc4cbf17069ad))
* Protect against invalidIfStale with || request ([#354](https://github.com/coinbase/rest-hooks/issues/354)) ([13f91d3](https://github.com/coinbase/rest-hooks/commit/13f91d327e9ee66eacdbb264e5d9d20f79788d15))
* Resource endpoint memoization ([744431e](https://github.com/coinbase/rest-hooks/commit/744431ef435dfab1969cd883f01b6a4b50b6c75d))
* SimpleRecord as schema in useDenormalized() ([#346](https://github.com/coinbase/rest-hooks/issues/346)) ([2b96335](https://github.com/coinbase/rest-hooks/commit/2b96335d2758b67fa5616fdafb6b338c8128c9a2))
* useFetcher() return types ([#347](https://github.com/coinbase/rest-hooks/issues/347)) ([d921cbe](https://github.com/coinbase/rest-hooks/commit/d921cbe41dc4b0d3f2c80bb9b6ef99dc71a8a86d))


### 📦 Package

* Add type exports: Normalize, Denormalize, and their nullables ([378078f](https://github.com/coinbase/rest-hooks/commit/378078f543526047ad76251e1ef73ae5899eaaf5))
* Bump babel runtime ([c6bf844](https://github.com/coinbase/rest-hooks/commit/c6bf844fcf1a483988d34b5f09faa03ceff179ec))
* Use @babel/runtime @ 7.12 ([e631f6a](https://github.com/coinbase/rest-hooks/commit/e631f6a8c435c5ef74b3809c8950a2caceca8763))


### 📝 Documentation

* Add link to debugging docs from readme ([d75cbe8](https://github.com/coinbase/rest-hooks/commit/d75cbe8983263835ba81befc87fc0579b0b1dc3b))
* Fix Endpoint def in readme example ([125ad57](https://github.com/coinbase/rest-hooks/commit/125ad57a1450d9b167b0d7172a2e836f83aae5e2))
* Fix tags ([987f0ed](https://github.com/coinbase/rest-hooks/commit/987f0ed7d4980c3276bb8c9701f606364dad93d8))
* Get rid of all references to asSchema() ([#339](https://github.com/coinbase/rest-hooks/issues/339)) ([01b878b](https://github.com/coinbase/rest-hooks/commit/01b878b85f7469a12e19912efc696a424663e5f5))
* Remove irrelevant tags ([ff137da](https://github.com/coinbase/rest-hooks/commit/ff137daac8c94cf9ab75259954714160ea142d79))
* Update @rest-hooks/core readme with Entity ([21e9d2e](https://github.com/coinbase/rest-hooks/commit/21e9d2e9e2c0a4d59630d9bb9e513586f02547f7))
* Update readme examples ([68c69ab](https://github.com/coinbase/rest-hooks/commit/68c69ab4f4aebadb93ac30a6c37672dc585683fd))
* Update readme tagline ([fe39b16](https://github.com/coinbase/rest-hooks/commit/fe39b1634535c265afe9a00fe44a3fea29773522))



## [1.0.0-rc.1](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-rc.0...@rest-hooks/core@1.0.0-rc.1) (2021-01-19)


### ⚠ 💥 BREAKING CHANGES

* Remove `normalize`, `denormalize`; use
`normalizr` package for those
* Resources will resolve with any nested
entities from their schemas, rather than the `pk` of those
entities

### 🚀 Features

* Resources can have nested entities ([#469](https://github.com/coinbase/rest-hooks/issues/469)) ([4eeeaae](https://github.com/coinbase/rest-hooks/commit/4eeeaae1026715be4e72a66cd94d81934f2b0ce7))


### 💅 Enhancement

* `endpoint` package only exports definitions ([#473](https://github.com/coinbase/rest-hooks/issues/473)) ([51dcafe](https://github.com/coinbase/rest-hooks/commit/51dcafe98631998a1db1959f2796d7122d96960b))
* Widen RestFetch types to make overriding not break ([#479](https://github.com/coinbase/rest-hooks/issues/479)) ([2bccf12](https://github.com/coinbase/rest-hooks/commit/2bccf12f7892ccbc1d342bd529b3659c2935fb71))



## 1.0.0-rc.0 (2021-01-14)

* enhance: Inferred endpoints expiry based on entities (#464) ([975e0d8](https://github.com/coinbase/rest-hooks/commit/975e0d8)), closes [#464](https://github.com/coinbase/rest-hooks/issues/464)
* enhance: Maintain referential equality globally (#403) ([e1e353d](https://github.com/coinbase/rest-hooks/commit/e1e353d)), closes [#403](https://github.com/coinbase/rest-hooks/issues/403)
* internal: Fix publish message (#461) ([e1691f5](https://github.com/coinbase/rest-hooks/commit/e1691f5)), closes [#461](https://github.com/coinbase/rest-hooks/issues/461)


### BREAKING CHANGE

* Node engine requirement of >=0.12
* useResource() inferred endpoint will sometimes
not trigger a fetch if entities are fresh enough




## 1.0.0-k.5 (2021-01-06)

* Expose BodyFromShape from core library ([060dcd3](https://github.com/coinbase/rest-hooks/commit/060dcd3))
* feat: Track and use entity resolution time ([54203f9](https://github.com/coinbase/rest-hooks/commit/54203f9))
* pkg: Use @babel/runtime @ 7.12 ([e631f6a](https://github.com/coinbase/rest-hooks/commit/e631f6a))





## 1.0.0-k.4 (2020-12-08)

* fix: Clear promises on cleanup (#422) ([bcb236e](https://github.com/coinbase/rest-hooks/commit/bcb236e)), closes [#422](https://github.com/coinbase/rest-hooks/issues/422)
* feat: Add useInvalidateDispatcher() (#413) ([e416c5f](https://github.com/coinbase/rest-hooks/commit/e416c5f)), closes [#413](https://github.com/coinbase/rest-hooks/issues/413)





## 1.0.0-k.3 (2020-09-08)

* fix: Only block suspense if errors are synthetic (#410) ([af8ab26](https://github.com/coinbase/rest-hooks/commit/af8ab26)), closes [#410](https://github.com/coinbase/rest-hooks/issues/410)
* feat: useFetchDispatcher() (#407) ([f4e45be](https://github.com/coinbase/rest-hooks/commit/f4e45be)), closes [#407](https://github.com/coinbase/rest-hooks/issues/407)
* internal: Upgrade build pkgs (#404) ([dc56530](https://github.com/coinbase/rest-hooks/commit/dc56530)), closes [#404](https://github.com/coinbase/rest-hooks/issues/404)





## 1.0.0-k.2 (2020-08-13)

**Note:** Version bump only for package @rest-hooks/core





## 1.0.0-k.1 (2020-08-12)

* enhance: Support React 17 (#397) ([a833f07](https://github.com/coinbase/rest-hooks/commit/a833f07)), closes [#397](https://github.com/coinbase/rest-hooks/issues/397)





## 1.0.0-k.0 (2020-08-09)

* feat: Add @rest-hooks/hooks for composable utilities (#393) ([b225a2a](https://github.com/coinbase/rest-hooks/commit/b225a2a)), closes [#393](https://github.com/coinbase/rest-hooks/issues/393)
* feat: Simple AbortController integration (#392) ([899563d](https://github.com/coinbase/rest-hooks/commit/899563d)), closes [#392](https://github.com/coinbase/rest-hooks/issues/392)





## 1.0.0-j.7 (2020-08-09)

* enhance: console instead of throw when missing frequency ([8708b1f](https://github.com/coinbase/rest-hooks/commit/8708b1f))
* fix: extend() correctly keeps options for FetchShape compat ([bf522a2](https://github.com/coinbase/rest-hooks/commit/bf522a2))





## 1.0.0-j.6 (2020-08-09)

* enhance: Simplify endpoint memoization and provide new extensions (#391) ([d874d0b](https://github.com/coinbase/rest-hooks/commit/d874d0b)), closes [#391](https://github.com/coinbase/rest-hooks/issues/391)
* fix: Resource endpoint memoization ([744431e](https://github.com/coinbase/rest-hooks/commit/744431e))





## 1.0.0-j.5 (2020-08-08)

* internal: Test using endpoints directly (#389) ([bb0e8fd](https://github.com/coinbase/rest-hooks/commit/bb0e8fd)), closes [#389](https://github.com/coinbase/rest-hooks/issues/389)
* feat: Support extra endpoint members and inheritance (#387) ([6ad5486](https://github.com/coinbase/rest-hooks/commit/6ad5486)), closes [#387](https://github.com/coinbase/rest-hooks/issues/387)





## 1.0.0-j.4 (2020-08-04)

* fix: Handle entities updated with new indexes (#384) ([2ee3bb6](https://github.com/coinbase/rest-hooks/commit/2ee3bb6)), closes [#384](https://github.com/coinbase/rest-hooks/issues/384)
* fix: Infer useFetcher() has no body when not present in fetch (#385) ([22dd399](https://github.com/coinbase/rest-hooks/commit/22dd399)), closes [#385](https://github.com/coinbase/rest-hooks/issues/385)





## 1.0.0-j.3 (2020-07-31)

**Note:** Version bump only for package @rest-hooks/core





## 1.0.0-j.2 (2020-07-27)

**Note:** Version bump only for package @rest-hooks/core





## 1.0.0-j.1 (2020-07-27)

* fix: Inferred return of useCache() (#377) ([ce7a4f7](https://github.com/coinbase/rest-hooks/commit/ce7a4f7)), closes [#377](https://github.com/coinbase/rest-hooks/issues/377)





## 1.0.0-j.0 (2020-07-27)

* feat: Add @rest-hooks/rest package (#375) ([5e5c125](https://github.com/coinbase/rest-hooks/commit/5e5c125)), closes [#375](https://github.com/coinbase/rest-hooks/issues/375)





## 1.0.0-i.4 (2020-07-22)

* internal: Add add more disruption to referntial test ([f249b40](https://github.com/coinbase/rest-hooks/commit/f249b40))
* docs: Add link to debugging docs from readme ([d75cbe8](https://github.com/coinbase/rest-hooks/commit/d75cbe8))





## 1.0.0-i.3 (2020-07-21)

* internal: Fix - in test make date of fetch consistent ([d9b5970](https://github.com/coinbase/rest-hooks/commit/d9b5970))
* internal: Fix remaining types in test ([b599927](https://github.com/coinbase/rest-hooks/commit/b599927))
* internal: Fix tests ([78332b3](https://github.com/coinbase/rest-hooks/commit/78332b3))
* feat: Add fetch request creation time to meta ([1a6242f](https://github.com/coinbase/rest-hooks/commit/1a6242f))





## 1.0.0-i.2 (2020-07-20)

* feat: Add DevToolsManager to integrate with redux-devtools (#371) ([aa171bc](https://github.com/coinbase/rest-hooks/commit/aa171bc)), closes [#371](https://github.com/coinbase/rest-hooks/issues/371)
* enhance: Add more information when network receive fails ([67ead66](https://github.com/coinbase/rest-hooks/commit/67ead66))
* docs: Fix Endpoint def in readme example ([125ad57](https://github.com/coinbase/rest-hooks/commit/125ad57))
* docs: Update readme tagline ([fe39b16](https://github.com/coinbase/rest-hooks/commit/fe39b16))





## 1.0.0-i.1 (2020-07-14)

* fix: Export Endpoint through core ([8b60dea](https://github.com/coinbase/rest-hooks/commit/8b60dea))





## 1.0.0-i.0 (2020-07-14)

* docs: Update readme examples ([68c69ab](https://github.com/coinbase/rest-hooks/commit/68c69ab))
* enhance: Make Endpoint compatible with FetchShape ([caa967c](https://github.com/coinbase/rest-hooks/commit/caa967c))
* enhance: Resource uses endpoint (#365) ([4472106](https://github.com/coinbase/rest-hooks/commit/4472106)), closes [#365](https://github.com/coinbase/rest-hooks/issues/365)


### BREAKING CHANGE

* getFetchOptions() -> getEndpointExtra()




## 1.0.0-h.0 (2020-07-13)

* pkg: Bump babel runtime ([c6bf844](https://github.com/coinbase/rest-hooks/commit/c6bf844))
* docs: Fix tags ([987f0ed](https://github.com/coinbase/rest-hooks/commit/987f0ed))
* docs: Remove irrelevant tags ([ff137da](https://github.com/coinbase/rest-hooks/commit/ff137da))





## 1.0.0-delta.0 (2020-07-08)

* feat: Deletes and invalidates trigger suspense always (#360) ([96175ba](https://github.com/coinbase/rest-hooks/commit/96175ba)), closes [#360](https://github.com/coinbase/rest-hooks/issues/360)
* feat: Resource.fetch() arguments reflect browser fetch() (#362) ([1d19421](https://github.com/coinbase/rest-hooks/commit/1d19421)), closes [#362](https://github.com/coinbase/rest-hooks/issues/362)


### BREAKING CHANGE

* - denormalize has third boolean value to track deletion
- deletes no long remove entities, but replace them with DELETE symbol (exported from normalizr)
- schema of delete shape should be the `new schemas.Delete()`
- useInvalidator()'s function calls will always suspend - even without invalidIfStale
- deleted entities that are required by a useResource() will now cause it to suspend rather than throwing `404`
- required entities missing from network response will now throw error in useResource() just like other unexpected deserializations
- FetchShape type is now just 'read' | 'mutate'. No more 'delete'. (use schema.Delete())
* - Removed Resource.fetchOptionsPlugin()
- Added Resource.getFetchInit() which is called in shape generators
- Resourece.fetch() interface changed to match browser fetch()




## 1.0.0-gamma.0 (2020-06-13)

**Note:** Version bump only for package @rest-hooks/core





## 1.0.0-beta.15 (2020-06-13)

* feat: Declarative schema deserialization (#355) ([9dbb019](https://github.com/coinbase/rest-hooks/commit/9dbb019)), closes [#355](https://github.com/coinbase/rest-hooks/issues/355)





## 1.0.0-beta.14 (2020-06-09)

* fix: Clear invalidIfStale protections on mount (#357) ([b9a89dc](https://github.com/coinbase/rest-hooks/commit/b9a89dc)), closes [#357](https://github.com/coinbase/rest-hooks/issues/357)
* internal: Add tests for malformed network responses ([96b788a](https://github.com/coinbase/rest-hooks/commit/96b788a))





## 1.0.0-beta.13 (2020-06-08)

* fix: Looping fetches should still expire at some point ([ef560a9](https://github.com/coinbase/rest-hooks/commit/ef560a9))





## 1.0.0-beta.12 (2020-06-06)

* fix: Normalizr errors reject and throw in useResource() (#352) ([1596b22](https://github.com/coinbase/rest-hooks/commit/1596b22)), closes [#352](https://github.com/coinbase/rest-hooks/issues/352)
* fix: Protect against invalidIfStale with || request (#354) ([13f91d3](https://github.com/coinbase/rest-hooks/commit/13f91d3)), closes [#354](https://github.com/coinbase/rest-hooks/issues/354)
* docs: Update @rest-hooks/core readme with Entity ([21e9d2e](https://github.com/coinbase/rest-hooks/commit/21e9d2e))
* internal: Add additional type test for useFetcher() ([2f5c876](https://github.com/coinbase/rest-hooks/commit/2f5c876))
* internal: Prepare tests to run in React Native env (#309) ([64efd70](https://github.com/coinbase/rest-hooks/commit/64efd70)), closes [#309](https://github.com/coinbase/rest-hooks/issues/309)





## [1.0.0-beta.11](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.10...@rest-hooks/core@1.0.0-beta.11) (2020-05-20)


### 🏠 Internal

* Bump typescript patch and get rid of comment ([17174ea](https://github.com/coinbase/rest-hooks/commit/17174ea13577571db1c1d2f2d3d7e7f64ea1ed57))



## [1.0.0-beta.10](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.9...@rest-hooks/core@1.0.0-beta.10) (2020-05-20)


### 🐛 Bug Fix

* Inferred return type of useFetcher() should be promise ([18f5654](https://github.com/coinbase/rest-hooks/commit/18f565491eecd69aa4b76774937e7dfd82822788))



## [1.0.0-beta.9](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.8...@rest-hooks/core@1.0.0-beta.9) (2020-05-20)


### 💅 Enhancement

* Infer a reasonble type for fetch responses by default ([9d8c44c](https://github.com/coinbase/rest-hooks/commit/9d8c44cf2dfc085a8d5ad16fcc14095849283c68))


### 🐛 Bug Fix

* Accept null as payload of fetch ([4ff4d06](https://github.com/coinbase/rest-hooks/commit/4ff4d0662e73e053746e7491cf946c55d71baf52))
* SimpleRecord as schema in useDenormalized() ([#346](https://github.com/coinbase/rest-hooks/issues/346)) ([2b96335](https://github.com/coinbase/rest-hooks/commit/2b96335d2758b67fa5616fdafb6b338c8128c9a2))
* useFetcher() return types ([#347](https://github.com/coinbase/rest-hooks/issues/347)) ([d921cbe](https://github.com/coinbase/rest-hooks/commit/d921cbe41dc4b0d3f2c80bb9b6ef99dc71a8a86d))



## [1.0.0-beta.8](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.7...@rest-hooks/core@1.0.0-beta.8) (2020-05-19)

**Note:** Version bump only for package @rest-hooks/core





## [1.0.0-beta.7](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.6...@rest-hooks/core@1.0.0-beta.7) (2020-05-19)

**Note:** Version bump only for package @rest-hooks/core





## [1.0.0-beta.6](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.5...@rest-hooks/core@1.0.0-beta.6) (2020-05-19)


### 🐛 Bug Fix

* No entity schemas should suspend when they have no results ([#344](https://github.com/coinbase/rest-hooks/issues/344)) ([d3cd45e](https://github.com/coinbase/rest-hooks/commit/d3cd45e03bd639c49bf010ff848d4a158f0e6bf9))



## [1.0.0-beta.5](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.4...@rest-hooks/core@1.0.0-beta.5) (2020-05-14)


### 📝 Documentation

* Get rid of all references to asSchema() ([#339](https://github.com/coinbase/rest-hooks/issues/339)) ([01b878b](https://github.com/coinbase/rest-hooks/commit/01b878b85f7469a12e19912efc696a424663e5f5))



## [1.0.0-beta.4](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.3...@rest-hooks/core@1.0.0-beta.4) (2020-05-13)

**Note:** Version bump only for package @rest-hooks/core





## [1.0.0-beta.3](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.2...@rest-hooks/core@1.0.0-beta.3) (2020-05-13)


### 💅 Enhancement

* Add back remaining normalizr exports to rest-hooks ([b6878ee](https://github.com/coinbase/rest-hooks/commit/b6878eebbf1572a4b859828da81a058bc5c118e3))


### 📦 Package

* Add type exports: Normalize, Denormalize, and their nullables ([378078f](https://github.com/coinbase/rest-hooks/commit/378078f543526047ad76251e1ef73ae5899eaaf5))



## [1.0.0-beta.2](https://github.com/coinbase/rest-hooks/compare/@rest-hooks/core@1.0.0-beta.1...@rest-hooks/core@1.0.0-beta.2) (2020-05-13)

**Note:** Version bump only for package @rest-hooks/core





## 1.0.0-beta.1 (2020-05-12)


### 💅 Enhancement

* New package @rest-hooks/core ([#336](https://github.com/coinbase/rest-hooks/issues/336)) ([bf490c0](https://github.com/coinbase/rest-hooks/commit/bf490c030feb8a0e35e96c6dd7d180e45ac8bfd0))
